#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from zephir.monitor.agentmanager.templates.PageTmpl import PageTmpl
from zephir.monitor.agentmanager.templates.SectionTmpl import SectionTmpl

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc8'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 8)
__CHEETAH_genTime__ = 1212063957.6172309
__CHEETAH_genTimestamp__ = 'Thu May 29 14:25:57 2008'
__CHEETAH_src__ = 'ManagerPageTmpl.tmpl'
__CHEETAH_srcLastModified__ = 'Tue Jan 22 15:16:48 2008'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class ManagerPageTmpl(PageTmpl):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        PageTmpl.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<!-- ManagerPageTmpl #encoding utf-8 -->

''')
        _v = VFFSL(SL,"head",False)("Zephir &mdash; " + VFFSL(SL,"host",True)) # '$head("Zephir &mdash; " + $host)' on line 5, col 1
        if _v is not None: write(_filter(_v, rawExpr='$head("Zephir &mdash; " + $host)')) # from line 5, col 1.
        write('''

<SCRIPT LANGUAGE="JavaScript">
<!--
function clear() {
        location.reload(false)
}
setTimeout ("clear()", 60000);
// -->
</SCRIPT>

<h1 id="title">''')
        _v = VFFSL(SL,"description",True) # '$description' on line 16, col 16
        if _v is not None: write(_filter(_v, rawExpr='$description')) # from line 16, col 16.
        write('''</h1>

<div id="nav">
''')
        if VFFSL(SL,"len",False)(VFFSL(SL,"manager.structure",True)) != 0: # generated from line 19, col 3
            write('''  <ol>
''')
            if VFFSL(SL,"show_clients",True) == True: # generated from line 21, col 5
                write('''    <li><a href="/agents/">Clients</a></li>
''')
            for section, agents in VFFSL(SL,"manager.structure",True): # generated from line 24, col 5
                write('''    <li><a href="#''')
                _v = VFFSL(SL,"section",True) # '$section' on line 25, col 19
                if _v is not None: write(_filter(_v, rawExpr='$section')) # from line 25, col 19.
                write('''">''')
                _v = VFFSL(SL,"section",True) # '$section' on line 25, col 29
                if _v is not None: write(_filter(_v, rawExpr='$section')) # from line 25, col 29.
                write('''</a></li>
''')
            write('''    <li><a href="/agents/''')
            _v = VFFSL(SL,"manager.client_name",True) # '$manager.client_name' on line 27, col 26
            if _v is not None: write(_filter(_v, rawExpr='$manager.client_name')) # from line 27, col 26.
            write('''/bilan/">Bilan Mensuel</a></li>
  </ol>
''')
        write('''</div> <!-- nav -->

<div id="content">
''')
        t = SectionTmpl()
        t.depth = 2
        t.content = VFFSL(SL,"manager.structure",True)
        t.manager = VFFSL(SL,"manager",True)
        _v = VFFSL(SL,"str",False)(VFFSL(SL,"t",True)) # '$str($t)' on line 38, col 1
        if _v is not None: write(_filter(_v, rawExpr='$str($t)')) # from line 38, col 1.
        write('''
</div> <!-- content -->
    
''')
        _v = VFFSL(SL,"foot",False)() # '$foot()' on line 41, col 1
        if _v is not None: write(_filter(_v, rawExpr='$foot()')) # from line 41, col 1.
        write('''
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_ManagerPageTmpl= 'respond'

## END CLASS DEFINITION

if not hasattr(ManagerPageTmpl, '_initCheetahAttributes'):
    templateAPIClass = getattr(ManagerPageTmpl, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(ManagerPageTmpl)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=ManagerPageTmpl()).run()


