#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from zephir.monitor.agentmanager.templates.AgentTmpl import AgentTmpl

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0rc8'
__CHEETAH_versionTuple__ = (2, 0, 0, 'candidate', 8)
__CHEETAH_genTime__ = 1212063959.283783
__CHEETAH_genTimestamp__ = 'Thu May 29 14:25:59 2008'
__CHEETAH_src__ = 'SectionTmpl.tmpl'
__CHEETAH_srcLastModified__ = 'Tue Jan 22 15:16:48 2008'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class SectionTmpl(Template):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        Template.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def respond(self, trans=None):



        ## CHEETAH: main method generated for this template
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''<!-- SectionTmpl #encoding utf-8 -->


''')
        for subtitle, agents in VFFSL(SL,"content",True): # generated from line 5, col 1
            if VFFSL(SL,"subtitle",True) is not None: # generated from line 6, col 3
                write('''    <h''')
                _v = VFFSL(SL,"depth",True)
                if _v is not None: write(_filter(_v))
                write(''' id="''')
                _v = VFFSL(SL,"subtitle",True) # '$subtitle' on line 7, col 25
                if _v is not None: write(_filter(_v, rawExpr='$subtitle')) # from line 7, col 25.
                write('''">''')
                _v = VFFSL(SL,"subtitle",True) # '$subtitle' on line 7, col 36
                if _v is not None: write(_filter(_v, rawExpr='$subtitle')) # from line 7, col 36.
                write('''</h''')
                _v = VFFSL(SL,"depth",True)
                if _v is not None: write(_filter(_v))
                write('''>
''')
            write('''  <ul>
''')
            for name in VFFSL(SL,"agents",True): # generated from line 10, col 3
                write('''    <li>''')
                _v = VFFSL(SL,"str",False)(AgentTmpl(searchList=[{'name':VFFSL(SL,"name",True), 'manager':VFFSL(SL,"manager",True)}])) # "$str(AgentTmpl(searchList=[{'name':$name, 'manager':$manager}]))" on line 11, col 9
                if _v is not None: write(_filter(_v, rawExpr="$str(AgentTmpl(searchList=[{'name':$name, 'manager':$manager}]))")) # from line 11, col 9.
                write('''</li>
''')
            write('''  </ul>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_SectionTmpl= 'respond'

## END CLASS DEFINITION

if not hasattr(SectionTmpl, '_initCheetahAttributes'):
    templateAPIClass = getattr(SectionTmpl, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(SectionTmpl)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=SectionTmpl()).run()


