# -*- coding: UTF-8 -*-
###########################################################################
# Eole NG - 2007
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr
###########################################################################

"""
Agent zephir pour l'étude des logs de clamav
"""

from zephir.monitor.agentmanager.agent import Agent
from zephir.monitor.agentmanager.data import HTMLData, TableData
from zephir.monitor.agentmanager import status
import random
import time

class ClamLog(Agent):
    def __init__(self, name, **params):
        Agent.__init__(self, name, **params)
        self.lastcolor = None
        self.status = status.OK()
        # cas où on met direct le résultat :)
        #self.data=[HTMLData(self.result())]
        self.table = TableData([
            ('vir', 'Virus', {'align':'center'}, None),
            ('com', 'Poste client', {'align':'center'}, None),
            ('nb', 'Occurences', {'align':'center'}, None)])
        title1 = HTMLData("<h3>Derniers virus détectés<h3>")
        self.table2 = TableData([
            #('day', 'Jour', {'align':'center'}, None),
            ('nb', 'Nombre de virus pour aujourd\'hui', {'align':'center'}, None)])
        self.data = [title1, self.table, HTMLData('<br>'), self.table2]
 
    def _color(self,vir):
        color = self.lastcolor
        while color == self.lastcolor :
            color = random.choice(('red', 'green', 'blue', 'deeppink' ))
        self.lastcolor = color
        return "<font color=\"%s\">%s</font>" % (color, vir)
         
    def measure(self):
        self.status = status.OK()
        fichier = "/var/log/syslog"
        # les logs ont max une semaine
        # on peut donc se contenter du numéro dans le mois :)
        today = str(time.localtime().tm_mday)
        #mymonth = str(time.localtime().tm_mon)
        try :
            fp = open(fichier,'r')
        except:
            self.status = status.Erreur()
            return { 'statistics' : [ {'vir' : 'ERREUR', 
                                   'com' : '----', 
                                   'nb'  : '----'  }],
                     'statistics2' : [] }
        lignes = fp.readlines()
        fp.close()
        dico = {}
        totalday = 0
        #lignes.reverse() # si on veut trier par date
        for ligne in lignes:
            if ligne.find("infected with virus") != -1 :
                ## mois (ang) et jour (num)
                day = ligne[4:6]
                #month = ligne[0:3]
                #date = ligne[4:6]+" "+ligne[0:3]
                ligne = ligne[ligne.find("'")+1:]
                next = ligne.find("' ")
                ## fichier
                fichier = ligne[0:next]
                ligne = ligne[next+23:]
                next = ligne.find("'")
                ## virus
                virus = ligne[0:next]
                ## client
                client = ligne[next+12:-2]
                if dico.has_key((virus,client)) :
                    dico[(virus,client)] += 1
                else:
                    dico[(virus,client)] = 1
                from twisted.python import log
                if int(day) == int(today) :
                    totalday += 1
        # status (plus de 5 virus aujourd'hui ?
        warninglevel = 1
        errorlevel = 10
        if totalday >= errorlevel :
            self.status = status.Error()
        elif totalday >= warninglevel :
            self.status = status.Warn()
        self.measure_data['nb'] = str(totalday)

        res2 = { 'nb'  : str(totalday) }
        #'day' : today+"/"+mymonth,
                
        if dico != {} :
            result = []
            cles = dico.keys()
            for cle in cles :
                result.append({ 'vir' : self._color(cle[0]),
                                'com' : cle[1],
                                'nb'  : dico[cle]
                              })
            return { 'statistics' : result,
                     'statistics2' : [ res2 ] }
            #return "<font color=red>"+virus+"</font> sur le client"+" "+client+" ("+date+")"
        return { 'statistics' : [ {'vir' : 'Aucun', 
                                   'com' : '----', 
                                   'nb'  : '----'  } ],
                 'statistics2' : [ res2 ] }
             

    def write_data(self):
        Agent.write_data(self)
        if self.last_measure is not None:
            self.table.table_data = self.last_measure.value['statistics']
            self.table2.table_data = self.last_measure.value['statistics2']
            
    def check_status(self):
        return self.status
 
