#!/usr/bin/env python
# -*- coding: utf-8 -*-
###########################################################################
# Eole NG - 2007  
# Copyright Pole de Competence Eole  (Ministere Education - Academie Dijon)
# Licence CeCill  cf /root/LicenceEole.txt
# eole@ac-dijon.fr 
#  
# regen_certs.py
#  
# script de regénération des certificats ssl
#       
###########################################################################
from creole import cert
from creole.config import cert_file, key_file
from creole.fonctionseole import get_services_actifs
import os

def regen_ssl_certs():
    # procédure à lancer et services à redémarrer pour regénérer les certificats
    ssl_serv = ['apache2','ead-server','ead-web','zephir','zephir_web','eole-sso','sentinelle']
    try:
        for ssl_file in [cert_file, key_file]:
            if os.path.isfile(ssl_file):
                os.unlink(ssl_file)
        # lancement de la procédure de génération du certificat
        cert.gen_certif()
    except:
        print "Erreur lors de la génération des certificats"
    else:
        # récupération des services activés
        active_serv = get_services_actifs()
        # redémarrage des services utilisant les certificats
        for service in ssl_serv:
            if service in active_serv:
                if os.path.isfile('/etc/init.d/%s' % service):
                    os.system('/etc/init.d/%s restart' % service)
